package Game;
//import com.example.

import java.util.Random;
import android.util.Log;

public class Environment {
	
	private String TAG = "Environment Controller: ";
	private StringBuilder result = new StringBuilder(60);
	private Cell cell;
	private int envWidth, envHeight;
	static final int SCORE_INCREMENT = 10;
	static final int BONUS_SCORE_INCREMENT = 20;
	public boolean cellSelected = false;
	public int CELL_X_POS, CELL_Y_POS;
	private int slopeX, slopeY; //m=(y2-y1)/(x2-x1)
	public boolean gameOver = false;
	public int score = 0;
	private int xSingularity, ySingularity;
	
	
	
	public Environment(int width, int height){
		this.envWidth = width;
		this.envHeight = height;
		cell = new Cell();//initialize setting from save later
		placeCell();
	}
	
	public void placeCell(){
		//assume right now no saved games and always initialize cell in center of environment
		cell.setCurrentLocation(this.envWidth/2, this.envHeight/2);
		this.CELL_X_POS = cell.getCurrentXLocation();
		this.CELL_Y_POS = cell.getCurrentYLocation();
		this.setRandomSingularity();
		this.calculateSlope(this.CELL_Y_POS, this.ySingularity, CELL_X_POS, this.xSingularity);
		
		Log.d(TAG, "------ placeCell() call -------");
		Log.d(TAG, result.append("X "+CELL_X_POS).toString());
		Log.d(TAG, result.append("Y: "+CELL_Y_POS).toString());
	}
		
	public void placeAntigens(){
		
	}
	
	public void update(float deltaTime){
		//keeps track of movement per frame
		this.moveCell();
	}
	
	public void calculateSlope(int y2, int y1, int x2, int x1){
		StringBuilder bld = new StringBuilder();
		bld.append(" slopeY: "+ this.slopeY).append(" slopeX: "+ this.slopeX);
		Log.d("-------ENVIRONMENT SLOPE-----------", bld.toString());
		Log.d("-------ENVIRONMENT SLOPE-----------", bld.toString());
		Log.d("-------ENVIRONMENT SLOPE-----------", bld.toString());
		Log.d("-------ENVIRONMENT SLOPE-----------", bld.toString());
		Log.d("-------ENVIRONMENT SLOPE-----------", bld.toString());
		Log.d("-------ENVIRONMENT SLOPE-----------", bld.toString());
		Log.d("-------ENVIRONMENT SLOPE-----------", bld.toString());
		Log.d("-------ENVIRONMENT SLOPE-----------", bld.toString());
		Log.d("-------ENVIRONMENT SLOPE-----------", bld.toString());
		Log.d("-------ENVIRONMENT SLOPE-----------", bld.toString());
		Log.d("-------ENVIRONMENT SLOPE-----------", bld.toString());
		
		Log.d("-------ENVIRONMENT SLOPE-----------", bld.toString());
		Log.d("-------ENVIRONMENT SLOPE-----------", bld.toString());
		Log.d("-------ENVIRONMENT SLOPE-----------", bld.toString());
		Log.d("-------ENVIRONMENT SLOPE-----------", bld.toString());
		Log.d("-------ENVIRONMENT SLOPE-----------", bld.toString());
		
		this.slopeY = (y2-y1);
		this.slopeX = (x2-x1);
	}
	
	public void moveCell(){
		int newXLoc = this.CELL_X_POS + (cell.speed*this.slopeX);
		int newYLoc = this.CELL_Y_POS + (cell.speed* this.slopeY);
		cell.setCurrentLocation(newXLoc, newYLoc);
		this.CELL_X_POS = cell.getCurrentXLocation();
		this.CELL_Y_POS = cell.getCurrentYLocation();
		
	}
	
	public void detectCollisions(){
		
	}
		
	public void setRandomSingularity(){
		Random r = new Random();
		this.setSingularity(r.nextInt(this.envWidth-1), r.nextInt(this.envHeight-1));
	}
	
	//unselected cells move to this xycoordinate
	public void setSingularity(int xSingularity, int ySingularity) {
		this.xSingularity = xSingularity;
		this.ySingularity = ySingularity;
	}
	
	
	
	//-------------------To Be Removed-----------------------------//
	public void setSelectedCell(int x, int y){
		/*	for(Cell cell : cells){
				if (cell.getCurrentXLocation() == x && cell.getCurrentYLocation() == y){
					cell.setSelected(true);
				}else{
					cell.setSelected(false);
				}
			}*/
		}
		
		public Cell getSelectedCell(){
			Cell ret = null;
		/*	for(Cell cell : cells){
				if(cell.isSelected() == true){
					ret = cell;
				}
			}*/
			return ret;
		}

}
