package Game;
//p96
import java.util.List;

import com.example.cells.Graphics.Graphics;
import com.example.cells.IO.Touch.TouchEvent;
import Screens.Screen;

public interface Game {
	
	public Screen getLoadingScreen();
	
	public Screen getCurrentScreen();
	
	void setScreen(Screen screen);
	
	List<TouchEvent> getUserInput();
	
	Graphics getGraphics();
	
	void startGame();
	
	void pauseGame();
	
	void quitGame();
	
}
